﻿package  
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.display.Shader;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.net.URLLoaderDataFormat;
	import flash.events.Event;

	public class PixelBender extends Sprite
	{
		
		//Image asset to be compiled into flash
		[Embed(source = 'assets/eagle.jpg')]
		private var EagleImage:Class;
		
		//The image bitmap your image will become
		private var image:Bitmap;
		//The shader, used as a container for the pixelbender filter
		private var shader:Shader;
		//The url loader to load the shader
		private var shaderLoader:URLLoader;
		
		private var frequency:Number;
		private var yangle:Number;
		private var direction:Number;
		
		public function PixelBender() 
		{
			//create the image out of the embedded image class
			image = new EagleImage();
			
			//create the shader
			shader = new Shader();

			//load the shader
			shaderLoader = new URLLoader();
			shaderLoader.dataFormat = URLLoaderDataFormat.BINARY;
			shaderLoader.addEventListener(Event.COMPLETE, shaderLoaded);
			//your filter file has to be relative to the compiled swf
			shaderLoader.load(new URLRequest("wiggle.pbj"));
			
			frequency = 0;
			direction = 1;
			yangle = 0;
		}
		
		private function shaderLoaded(e:Event):void 
		{
			try {
				//set up the shader
				shader.byteCode = shaderLoader.data; // error if invalid
				//set the source input to the bitmap data of the image 
				shader.data.src.input = image.bitmapData; // image input
				
				
				
				this.addEventListener(Event.ENTER_FRAME, onEnterFrame);
				
			}catch (error:Error)
			{
					trace("error" + error);
			}
		}
		
		private function onEnterFrame(e:Event):void 
		{
			
				frequency = 0.1;
				
				yangle += direction;
				if (yangle >10)
				{
					direction = -1;
				}
				if (yangle < -10)
				{
					direction = 1;
				}
				
				//the parameters of the filter. The wiggle filter has frequency, xangle and yangle.
				shader.data.frequency.value = [frequency];
				shader.data.xangle.value = [0];
				shader.data.yangle.value = [yangle];
				
				//draw the shader onto the screen in a rectangle
				this.graphics.clear();
				this.graphics.beginShaderFill(shader);
				this.graphics.drawRect(0, 0, 800, 600);
		}
		
	}
	
}