﻿package  
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.media.Video;
	import flash.media.Camera;
	import flash.text.TextField;
	
	import flash.display.Shader;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.net.URLLoaderDataFormat;
	
	/**
	* ...
	* @author Carly Gooch
	*/
	public class WebcamTransparent extends Sprite
	{
		private var videoBitmap:Bitmap;
		private var videoBitmapData:BitmapData;
		private var video:Video;
		
		private var snapButton:Sprite;
		private var startButton:Sprite;
		
		private var snapImage:Bitmap;
		private var snapImageData:BitmapData;
		
		
		//The shader, used as a container for the pixelbender filter
		private var shader:Shader;
		//The url loader to load the shader
		private var shaderLoader:URLLoader;
		
		public function WebcamTransparent() 
		{
			video = new Video();
			video.attachCamera(Camera.getCamera());
			
			videoBitmapData = new BitmapData(video.width, video.height);
			videoBitmap = new Bitmap(videoBitmapData);
			
			
			//this.addChild(videoBitmap);
			
			snapButton = new Sprite();
			snapButton.graphics.beginFill(0x000000, 1);
			snapButton.graphics.drawRect(0, 0, 100, 30);
			snapButton.x = 0;
			snapButton.y = video.height + 10;
			var snapText:TextField = new TextField();
			snapText.text = "Snap background";
			snapText.textColor = 0xFFFFFF;
			snapText.selectable = false;
			snapButton.addChild(snapText);
			
			
			startButton = new Sprite();
			startButton.graphics.beginFill(0x000000, 1);
			startButton.graphics.drawRect(0, 0, 100, 30);
			startButton.x = snapButton.x + snapButton.width + 10;
			startButton.y = video.height + 10;
			
			
			
			var startText:TextField = new TextField();
			startText.text = "Start Recording";
			startText.textColor = 0xFFFFFF;
			startText.selectable = false;
			startButton.addChild(startText);
			
			this.addChild(snapButton);
			this.addChild(startButton);
			
			//create the shader
			shader = new Shader();

			//load the shader
			shaderLoader = new URLLoader();
			shaderLoader.dataFormat = URLLoaderDataFormat.BINARY;
			shaderLoader.addEventListener(Event.COMPLETE, shaderLoaded);
			//your filter file has to be relative to the compiled swf
			shaderLoader.load(new URLRequest("camera.pbj"));
			
		}
		
		private function shaderLoaded(e:Event):void 
		{
			startButton.addEventListener(MouseEvent.CLICK, startRecord);
			snapButton.addEventListener(MouseEvent.CLICK, onSnap);
			
			try {
				//set up the shader
				shader.byteCode = shaderLoader.data; // error if invalid
				//set the source input to the bitmap data of the image 
				
				
				
				
				

				
			}catch (error:Error)
			{
					trace("error" + error);
			}
		}
		
		private function startRecord(e:MouseEvent):void 
		{
			this.addEventListener(Event.ENTER_FRAME, update);
		}
		
		private function onSnap(e:MouseEvent):void 
		{
			snapImageData = new BitmapData(video.width, video.height);
			snapImageData.draw(video);
			snapImage = new Bitmap(snapImageData);
			
			snapImage.x = video.width;
			snapImage.y = 0;
			this.addChild(snapImage);
			
		}
		
		private function update(e:Event):void 
		{
			videoBitmapData.draw(video);
			
			
			shader.data.backgroundInput.input = snapImageData; // image input
			shader.data.videoFeedInput.input = videoBitmapData; // image input
			
			//draw the shader onto the screen in a rectangle
			this.graphics.clear();
			this.graphics.beginShaderFill(shader);
			this.graphics.drawRect(0, 0, video.width, video.height);
		}
		
	}
	
}